#weapons

#judgement day

#judgement

execute as @a[nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",tag:{Judgement:1b}}},scores={use=1..,judgement_cooldown=0}] at @s run summon armor_stand ~ ~ ~ {Marker:1b,Invisible:1b,Tags:["projectile","judgement_projectile"]}
execute as @a[nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",tag:{Judgement:1b}}},scores={use=1..,judgement_cooldown=0}] at @s run playsound sfx.shoot master @s ~ ~ ~ 100
scoreboard players set @a[nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",tag:{Judgement:1b}}},scores={use=1..,judgement_cooldown=0}] judgement_cooldown 40
execute at @e[tag=judgement_projectile] positioned ~ ~1.3 ~ run function b:judgement_projectile
tp @e[tag=judgement_projectile,scores={projectile_lifetime=1..3}] @a[limit=1]
execute as @e[tag=judgement_projectile] at @s run tp @s ^ ^ ^0.4
execute as @e[tag=judgement_projectile] at @s run execute at @e[type=!#not_target,distance=..1.5,nbt={HurtTime:0s}] run playsound sfx.collide master @a ~ ~ ~ 0.5
execute as @e[tag=judgement_projectile] at @s run execute as @e[type=!#not_target,distance=..1.5] run damage @s 8 thrown by @a[limit=1]
execute as @e[tag=judgement_projectile] at @s anchored eyes unless block ~ ~1 ~ #air run playsound block.fire.extinguish master @a ~ ~ ~ 10
execute as @e[tag=judgement_projectile] at @s anchored eyes unless block ~ ~1 ~ #air run kill @s
execute at @e[tag=judgement_projectile,scores={projectile_lifetime=25..}] run playsound block.fire.extinguish master @a ~ ~ ~ 10
kill @e[tag=judgement_projectile,scores={projectile_lifetime=25..}]

#skybreaker

execute as @a[nbt={Inventory:[{id:"minecraft:carrot_on_a_stick",tag:{Judgement:1b},Slot:-106b}]},scores={use=1..,shockwave_cooldown=0}] at @s run function b:judgement_shockwave
execute as @a[nbt={Inventory:[{id:"minecraft:carrot_on_a_stick",tag:{Judgement:1b},Slot:-106b}]},scores={use=1..,shockwave_cooldown=0}] at @s run playsound entity.ender_dragon.flap master @s ~ ~ ~ 15 2
effect give @a[nbt={Inventory:[{id:"minecraft:carrot_on_a_stick",tag:{Judgement:1b},Slot:-106b}]},scores={use=1..,shockwave_cooldown=0}] levitation 1 16 true
scoreboard players set @a[nbt={Inventory:[{id:"minecraft:carrot_on_a_stick",tag:{Judgement:1b},Slot:-106b}]},scores={use=1..,shockwave_cooldown=0}] shockwave_cooldown 100
execute at @a[scores={shockwave_cooldown=85..}] run particle end_rod ~ ~1 ~ 0.25 0.25 0.25 0 20
effect clear @a[nbt={ActiveEffects:[{Id:25,Amplifier:16b,Duration:10}]}] levitation
execute at @e[tag=judgement_shockwave] run particle dust 1 1 1 1 ~ ~ ~ 0.1 0.1 0.1 0 35
execute as @e[tag=judgement_shockwave] at @s run tp @s ^ ^ ^0.4
execute as @e[tag=judgement_shockwave] at @s run execute at @e[type=!#not_target,distance=..1.5,nbt={HurtTime:0s}] run playsound sfx.collide master @a ~ ~ ~ 0.1 2
execute as @e[tag=judgement_shockwave] at @s run execute as @e[type=!#not_target,distance=..1.5] run damage @s 5 thrown by @a[limit=1]
kill @e[tag=judgement_shockwave,scores={projectile_lifetime=15..}]
execute as @a[scores={shockwave_cooldown=1}] at @s run playsound item.trident.return master @s ~ ~ ~ 100
execute at @a[scores={shockwave_cooldown=1}] run particle soul ~ ~1 ~ 0.25 0.5 0.25 0.1 35

#seraphim stuff

execute at @e[tag=seraphim] if entity @e[scores={difficulty=1..2}] if entity @e[tag=seraphim] unless entity @e[tag=seraphim_base] run summon silverfish ~ ~ ~ {Silent:1b,PersistenceRequired:1b,Tags:["seraphim_base","enemy"],Attributes:[{Name:"generic.knockback_resistance",Base:1},{Name:"generic.movement_speed",Base:0.23},{Name:"generic.attack_damage",Base:0},{Name:"generic.follow_range",Base:100}]}
execute at @e[tag=seraphim] if entity @e[scores={difficulty=3}] if entity @e[tag=seraphim] unless entity @e[tag=seraphim_base] run summon silverfish ~ ~ ~ {Silent:1b,PersistenceRequired:1b,Tags:["seraphim_base","enemy"],Attributes:[{Name:"generic.knockback_resistance",Base:1},{Name:"generic.movement_speed",Base:0.3},{Name:"generic.attack_damage",Base:0},{Name:"generic.follow_range",Base:100}]}
effect give @e[tag=seraphim] resistance infinite 1 true
effect give @e[tag=seraphim_base] invisibility infinite 1 true
effect give @e[tag=seraphim] invisibility infinite 1 true
execute as @e[tag=seraphim,scores={spell2=..330}] at @s run tp @s ~ ~ ~ facing entity @a[limit=1,tag=!spectator]
execute as @e[tag=seraphim,scores={spell2=345..}] at @s run tp @s ~ ~ ~ facing entity @a[limit=1,tag=!spectator]
execute at @e[tag=seraphim] run tp @e[tag=seraphim_model] ~ ~ ~ ~ 0
execute at @e[tag=seraphim_base] run tp @e[tag=seraphim] ~ ~1.5 ~
execute unless entity @e[tag=seraphim] run kill @e[tag=seraphim_base]
execute if entity @e[tag=seraphim] run function b:enemy_seraphim
execute if score .dummy seraphim_alive matches 1.. unless entity @e[tag=seraphim] run function b:seraphim_death

#begin map

execute if score .dummy begin_map matches 1 run tellraw @p [{"text":"[Skip Intro]","color":"green","bold":true,"clickEvent":{"action":"run_command","value":"/scoreboard players set .dummy begin_map 1300"}},{"text":"\n"}]
execute if score .dummy begin_map matches 40 run tellraw @a [{"text":"[","color":"black"},{"text":"The Harbinger","color":"dark_gray","obfuscated":true},{"text":"] "},{"text":"Your goal is to destroy ","color":"gray"},{"text":"Heaven","color":"gold","bold":true},{"text":".","color":"gray"}]
execute if score .dummy begin_map matches 120 run tellraw @a [{"text":"[","color":"black"},{"text":"The Harbinger","color":"dark_gray","obfuscated":true},{"text":"] "},{"text":"But there will be a thorn in your side.","color":"gray"}]
execute if score .dummy begin_map matches 200 run tellraw @a [{"text":"[","color":"black"},{"text":"The Harbinger","color":"dark_gray","obfuscated":true},{"text":"] "},{"text":"The Seraphim, whom guards the gates to heaven.","color":"gray"}]
execute if score .dummy begin_map matches 280 run tellraw @a [{"text":"[","color":"black"},{"text":"The Harbinger","color":"dark_gray","obfuscated":true},{"text":"] "},{"text":"Kill them.","color":"gray"}]
execute if score .dummy begin_map matches 360 run tellraw @a [{"text":"[","color":"black"},{"text":"The Harbinger","color":"dark_gray","obfuscated":true},{"text":"] "},{"text":"If you succeed, you will be rewarded.","color":"gray"}]
execute if score .dummy begin_map matches 420 run tellraw @a [{"text":"[","color":"black"},{"text":"The Harbinger","color":"dark_gray","obfuscated":true},{"text":"] "},{"text":"Now go, kill ","color":"gray"},{"text":"The Seraphim","color":"gold","bold":true},{"text":".","color":"gray"}]
execute if score .dummy begin_map matches 505.. run tp @a 1 -52 -45 facing entity @e[tag=seraphim_model,limit=1]
execute if score .dummy begin_map matches 505 positioned 1 -51 -56 rotated 180 0 run function animated_java:seraphim/summon
execute if score .dummy begin_map matches 505 as @e[tag=seraphim_model] run function animated_java:seraphim/animations/idle/play
execute if score .dummy begin_map matches 520 run tellraw @a [{"text":"[","color":"gold"},{"text":"The Seraphim","color":"yellow","obfuscated": true},{"text":"] "},{"text":"Hm?","color":"gray"}]
execute if score .dummy begin_map matches 580 run tellraw @a [{"text":"[","color":"gold"},{"text":"The Seraphim","color":"yellow","obfuscated": true},{"text":"] "},{"text":"Who dares approach these ruins?","color":"gray"}]
execute if score .dummy begin_map matches 601..610 as @e[tag=seraphim_model] at @s run tp @s ~ ~ ~ ~18 0
execute if score .dummy begin_map matches 690 run tellraw @a [{"text":"[","color":"gold"},{"text":"The Seraphim","color":"yellow","obfuscated": true},{"text":"] "},{"text":"You, you know who I am, right?","color":"gray"}]
execute if score .dummy begin_map matches 770 run tellraw @a [{"text":"[","color":"gold"},{"text":"The Seraphim","color":"yellow","obfuscated": true},{"text":"] "},{"text":"What do you want?","color":"gray"}]
execute if score .dummy begin_map matches 850 run tellraw @a [{"text":"[","color":"gray"},{"text":"You draw out your blade.","color":"white"},{"text":"]"}]
execute if score .dummy begin_map matches 930 run tellraw @a [{"text":"[","color":"gold"},{"text":"The Seraphim","color":"yellow"},{"text":"] "},{"text":"Seriously, answer my question, I'm The Seraphim, I don't have forever.","color":"gray"}]
execute if score .dummy begin_map matches 1010 run tellraw @a [{"text":"[","color":"gold"},{"text":"The Seraphim","color":"yellow"},{"text":"] "},{"text":"...You're not backing off, are you?","color":"gray"}]
execute if score .dummy begin_map matches 1090 run tellraw @a [{"text":"[","color":"gold"},{"text":"The Seraphim","color":"yellow"},{"text":"] "},{"text":"*sigh* Just... go away at this point.","color":"gray"}]
execute if score .dummy begin_map matches 1170 run tellraw @a [{"text":"[","color":"gray"},{"text":"You send out a judgement shot at The Seraphim.","color":"white"},{"text":"]"}]
execute if score .dummy begin_map matches 1170 as @a at @s run summon armor_stand ~ ~ ~ {Marker:1b,Invisible:1b,Tags:["projectile","judgement_projectile"]}
execute if score .dummy begin_map matches 1170 as @a at @s run playsound sfx.shoot master @s ~ ~ ~ 100
execute if score .dummy begin_map matches 1194 as @a at @s run playsound sfx.collide master @a ~ ~ ~ 0.5
execute if score .dummy begin_map matches 1194 run kill @e[tag=judgement_projectile]
execute if score .dummy begin_map matches 1194 run tellraw @a [{"text":"[","color":"gold"},{"text":"The Seraphim","color":"yellow"},{"text":"] "},{"text":"Ack!","color":"gray"}]
execute if score .dummy begin_map matches 1270 run tellraw @a [{"text":"[","color":"gold"},{"text":"The Seraphim","color":"yellow"},{"text":"] "},{"text":"Fine! Is this how you want to play?!","color":"gray"}]
execute if score .dummy begin_map matches 1300 run function b:begin_bossfight

#death cutscene

tp @e[tag=seraphim_model] @e[tag=seraphim_death,limit=1]
execute as @e[tag=seraphim_death] at @s run tp @s ~ ~ ~ facing entity @a[limit=1]
execute as @e[tag=seraphim_death] at @s run tp @s ~ ~ ~ ~ 0
execute at @e[tag=seraphim_death] positioned ^ ^ ^0.01 run particle falling_lava ~ ~1 ~ 0.1 0.1 0.1 0.01 10
execute at @e[tag=seraphim_death] positioned ^ ^ ^0.01 run particle falling_lava ~ ~1 ~ 0.1 0.1 0.1 0.01 10
execute at @e[tag=seraphim_death] positioned ^ ^ ^0.01 run particle falling_lava ~ ~1 ~ 0.1 0.1 0.1 0.01 10
execute if score .dummy seraphim_death matches 2.. run tp @a 1 -52 -52 180 0
execute if score .dummy seraphim_death matches 1.. run scoreboard players add .dummy seraphim_death 1
execute if score .dummy seraphim_death matches 2 positioned 1 -52 -56 run function animated_java:seraphim/summon/seraphim_phase2
execute if score .dummy seraphim_death matches 2 run summon armor_stand 1 -52 -56 {Marker:1b,Invisible:1b,Tags:["seraphim_death"]}
execute as @e[tag=seraphim_model] if score .dummy seraphim_death matches 2..380 run function animated_java:seraphim/animations/death/play
execute if score .dummy seraphim_death matches 100 run tellraw @a [{"text":"[","color":"dark_red"},{"text":"The Seraphim","color":"red"},{"text":"] "},{"text":"Ugh...","color": "gray"}]
execute if score .dummy seraphim_death matches 180 run tellraw @a [{"text":"[","color":"dark_red"},{"text":"The Seraphim","color":"red"},{"text":"] "},{"text":"I don't understand why...","color": "gray"}]
execute if score .dummy seraphim_death matches 260 run tellraw @a [{"text":"[","color":"dark_red"},{"text":"The Seraphim","color":"red"},{"text":"] "},{"text":"You...","color": "gray"}]
execute if score .dummy seraphim_death matches 340 run tellraw @a [{"text":"[","color":"dark_red"},{"text":"The Seraphim","color":"red"},{"text":"] "},{"text":"You would ","color": "gray"},{"text":"KILL ","bold": true},{"text":"me...","color": "gray"}]
execute if score .dummy seraphim_death matches 420 run tellraw @a [{"text":"[","color":"dark_red"},{"text":"The Seraphim","color":"red"},{"text":"] "},{"text":"Just why do you seek bloodshed.","color": "gray"}]
execute if score .dummy seraphim_death matches 500 run tellraw @a [{"text":"[","color":"dark_red"},{"text":"The Seraphim","color":"red"},{"text":"] "},{"text":"Just...","color": "gray"}]
execute if score .dummy seraphim_death matches 580 run tellraw @a [{"text":"[","color":"dark_red"},{"text":"The Seraphim","color":"red"},{"text":"] "},{"text":"why...","color": "gray"}]
execute if score .dummy seraphim_death matches 580 run function animated_java:seraphim/remove/all
execute at @e[tag=seraphim_death] if score .dummy seraphim_death matches 580 run playsound sfx.seraphim.scream master @a ~ ~ ~ 5 0
execute at @e[tag=seraphim_death] if score .dummy seraphim_death matches 580 run particle flame ~ ~1 ~ 0.5 0.5 0.5 0.1 3500
execute as @e[tag=seraphim_death] if score .dummy seraphim_death matches 580 run kill @s
execute if score .dummy seraphim_death matches 660 run tellraw @a [{"text":"[","color":"gray"},{"text":"Time to watch Heaven experience Hell","color":"white"},{"text":"]"}]
execute if score .dummy seraphim_death matches 720 run function b:map_end

#bossbar

execute if entity @e[tag=seraphim] run bossbar set seraphim visible true
execute unless entity @e[tag=seraphim] run bossbar set seraphim visible false
execute as @e[tag=seraphim] store result bossbar seraphim value run data get entity @s Health
execute as @e[tag=seraphim] store result bossbar seraphim max run attribute @s generic.max_health get
bossbar add seraphim {"text":"The Seraphim","color":"gold","bold":true,"underlined":true}
execute unless score .dummy seraphim_phase2 matches 1 run bossbar set seraphim color yellow
bossbar set seraphim style notched_10
bossbar set seraphim players @a

#spawn enemies

execute as @e[tag=enemy_spawn] at @s run function b:spawn_enemies
execute if entity @e[tag=priest] run function b:enemy_priest

#style stuff

execute as @a unless score @s highest_style matches 0.. run scoreboard players set @s highest_style 0
execute if entity @e[tag=seraphim] run scoreboard players add @a time_tick 1
scoreboard players add @a[scores={time_tick=20}] time_seconds 1
scoreboard players add @a[scores={time_seconds=60}] time_minute 1
scoreboard players reset @a[scores={time_tick=20}] time_tick
scoreboard players reset @a[scores={time_seconds=60}] time_seconds
scoreboard players add @a[scores={damage_kills=1..}] hit 1250
scoreboard players add @a[scores={damage=1..}] hit 1

#scoreboards

effect give @a[scores={difficulty=1..2,death=1..}] regeneration 1 255 true
effect give @a[scores={difficulty=3,death=1..}] absorption infinite 4 true
scoreboard players reset @a[scores={death=1..}] judgement_cooldown
scoreboard players reset @a[scores={death=1..}] shockwave_cooldown
execute as @a[scores={death=1..}] run function b:give_beginning_stuff
scoreboard objectives setdisplay list highest_style
scoreboard objectives add highest_style dummy
scoreboard objectives add kills totalKillCount
scoreboard objectives add damage_kills totalKillCount
scoreboard objectives add damage custom:damage_dealt
scoreboard objectives add hit dummy
scoreboard objectives add difficulty dummy
scoreboard objectives add style dummy
scoreboard objectives add time_tick dummy
scoreboard objectives add time_seconds dummy
scoreboard objectives add time_minute dummy
scoreboard objectives add total_death_count deathCount
scoreboard objectives add boss_death_count deathCount
scoreboard objectives add death deathCount
scoreboard objectives add enemy_spawn dummy
scoreboard objectives add y_level dummy
scoreboard objectives add enemy_hp dummy
scoreboard objectives add spell1 dummy
scoreboard objectives add spell2 dummy
scoreboard objectives add spell3 dummy
scoreboard objectives add spell4 dummy
scoreboard objectives add spell5 dummy
scoreboard objectives add spell6 dummy
scoreboard objectives add use used:carrot_on_a_stick
scoreboard objectives add projectile_lifetime dummy
scoreboard objectives add judgement_cooldown dummy
scoreboard objectives add shockwave_cooldown dummy
scoreboard objectives add begin_map dummy
execute as @e store result score @s y_level run data get entity @s Pos[1]
scoreboard players reset @a damage_kills
scoreboard players reset @a damage
execute unless entity @a[scores={difficulty=1..}] run scoreboard players set @a difficulty 1
execute unless entity @a[scores={difficulty=1..3}] run scoreboard players set @a difficulty 3
scoreboard players add @a[scores={death=1..}] death 1
scoreboard players reset @a[scores={death=3..}] death
execute as @e[tag=enemy] store result score @s enemy_hp run data get entity @s Health
execute unless entity @a[scores={judgement_cooldown=0..}] run scoreboard players set @a judgement_cooldown 0
execute unless entity @a[scores={shockwave_cooldown=0..}] run scoreboard players set @a shockwave_cooldown 0
scoreboard players reset @a use
scoreboard players add @e[tag=projectile] projectile_lifetime 1
scoreboard players remove @a[scores={judgement_cooldown=1..}] judgement_cooldown 1
scoreboard players remove @a[scores={shockwave_cooldown=1..}] shockwave_cooldown 1
execute if score .dummy begin_map matches 1.. run scoreboard players add .dummy begin_map 1

#seraphim scoreboard

scoreboard objectives add seraphim_alive dummy
scoreboard objectives add seraphim_music dummy
scoreboard objectives add seraphim_phase1 dummy
scoreboard objectives add seraphim_phase2 dummy
scoreboard objectives add seraphim_blink dummy
scoreboard objectives add seraphim_death dummy

#advancements

advancement grant @a only b:root
advancement grant @a[x=-2,y=-60,z=13,distance=..1,tag=!spectator] only b:plushie
execute if block -15 -59 -8 warped_button[powered=true] run advancement grant @a only b:cheat
advancement grant @a[scores={total_death_count=1..}] only b:died
advancement grant @a[scores={total_death_count=10..}] only b:died_10
advancement grant @a[scores={total_death_count=50..}] only b:died_50
advancement grant @a[scores={total_death_count=100..}] only b:died_100

#other details

execute positioned -2 -59 10 run particle block redstone_block ~ ~.5 ~ 0.2 0.2 0.2 0 1
execute if entity @a[x=-2,y=-60,z=13,distance=..1,tag=!spectator] run title @a actionbar {"text":"Franklo784 Plushie: I demand blood","color":"dark_red","bold":true}
execute if entity @a[x=-2,y=-60,z=13,distance=..1,tag=!spectator] run playsound entity.magma_cube.squish master @a ~ ~ ~ 1 2
execute as @e[type=text_display] at @s run tp @s ~ ~ ~ facing entity @p
execute as @e[type=text_display] at @s run tp @s ~ ~ ~ ~ 0
execute as @a[scores={difficulty=1..2}] run attribute @s generic.max_health base set 40
execute as @a unless score @s difficulty matches 1..2 run attribute @s generic.max_health base set 20
kill @a[gamemode=!creative,gamemode=!spectator,scores={y_level=..-75}]
execute as @e[tag=seraphim,scores={y_level=..-75}] run tp @s 1 -55 -56
time set midnight